var call_counter = require("./call_counter");

function multiply(x, y) {
	call_counter();
	return x * y;
}

function divide(x, y) {
	call_counter();
	return x / y;
}

function fibo(count) {
	call_counter();
	return _fibo(count);
}

function _fibo(count, counter, first, second) {
	//TODO validate count
	if (count === 0) return 0;
	if (counter === undefined) {
		//initialize
		counter = 1;
		first = 1;
		second = 2;
	}
	var result = first + second;
	if (counter === count) {
		return result;
	}
	return _fibo(count, counter++, second, result);
}

module.exports = {
	Multiplication: multiply,
	Division: divide,
	Fibonacci: fibo
}